diff --git a/src/common/Parameter.cpp b/src/common/Parameter.cpp
index ef8788c33..e3fb8d892 100644
--- a/src/common/Parameter.cpp
+++ b/src/common/Parameter.cpp
@@ -174,6 +174,7 @@ bool Parameter::can_extend_range()
    case ct_freq_shift:
    case ct_decibel_extendable:
    case ct_decibel_narrow_extendable:
+   case ct_oscspread:
       return true;
    }
    return false;
@@ -769,6 +770,8 @@ float Parameter::get_extended(float f)
       return 3.f * f;
    case ct_decibel_narrow_extendable:
       return 5.f * f;
+   case ct_oscspread:
+      return 12.f * f;
    default:
       return f;
    }
@@ -980,9 +983,9 @@ void Parameter::get_display(char* txt, bool external, float ef)
          break;
       case ct_oscspread:
          if (absolute)
-            sprintf(txt, "%.1f Hz", 16.f * f);
+            sprintf(txt, "%.1f Hz", 16.f * get_extended( f ));
          else
-            sprintf(txt, "%.1f cents", f * 100.f);
+            sprintf(txt, "%.1f cents", get_extended( f ) * 100.f);
          break;
       case ct_detuning:
          sprintf(txt, "%.1f cents", f * 100.f);
diff --git a/src/common/dsp/SampleAndHoldOscillator.cpp b/src/common/dsp/SampleAndHoldOscillator.cpp
index bc183add4..82bc8648f 100644
--- a/src/common/dsp/SampleAndHoldOscillator.cpp
+++ b/src/common/dsp/SampleAndHoldOscillator.cpp
@@ -78,7 +78,7 @@ void SampleAndHoldOscillator::init(float pitch, bool is_display)
       else
       {
          double drand = (double)rand() / RAND_MAX;
-         double detune = localcopy[id_detune].f * (detune_bias * float(i) + detune_offset);
+         double detune = oscdata->p[5].get_extended(localcopy[id_detune].f) * (detune_bias * float(i) + detune_offset);
          // double t = drand * max(2.0,dsamplerate_os / (16.35159783 *
          // pow((double)1.05946309435,(double)pitch)));
          double st = drand * storage->note_to_pitch_tuningctr(detune) * 0.5;
@@ -128,7 +128,7 @@ void SampleAndHoldOscillator::convolute(int voice, bool FM, bool stereo)
 {
    float detune = drift * driftlfo[voice];
    if (n_unison > 1)
-      detune += localcopy[id_detune].f * (detune_bias * float(voice) + detune_offset);
+      detune += oscdata->p[5].get_extended(localcopy[id_detune].f) * (detune_bias * float(voice) + detune_offset);
 
    float sub = l_sub.v;
 
@@ -167,6 +167,7 @@ void SampleAndHoldOscillator::convolute(int voice, bool FM, bool stereo)
    {
       // see the comment in SurgeSuperOscillator in the absolute branch
       t = storage->note_to_pitch_inv_ignoring_tuning( detune * storage->note_to_pitch_inv_ignoring_tuning( pitch ) * 16 / 0.9443 );
+      if( t < 0.1 ) t = 0.1;
    }
    else
        t = storage->note_to_pitch_inv_tuningctr(detune + l_sync.v);
diff --git a/src/common/dsp/SurgeSuperOscillator.cpp b/src/common/dsp/SurgeSuperOscillator.cpp
index b51dba5da..5b0831f26 100644
--- a/src/common/dsp/SurgeSuperOscillator.cpp
+++ b/src/common/dsp/SurgeSuperOscillator.cpp
@@ -266,7 +266,7 @@ void SurgeSuperOscillator::init(float pitch, bool is_display)
       else
       {
          double drand = (double)rand() / RAND_MAX;
-         double detune = localcopy[id_detune].f * (detune_bias * float(i) + detune_offset);
+         double detune = oscdata->p[5].get_extended(localcopy[id_detune].f) * (detune_bias * float(i) + detune_offset);
          // double t = drand * max(2.0,dsamplerate_os / (16.35159783 *
          // pow((double)1.05946309435,(double)pitch)));
          // used to be 0.25 * detune - 12
@@ -334,7 +334,7 @@ template <bool FM> void SurgeSuperOscillator::convolute(int voice, bool stereo)
    */
    float detune = drift * driftlfo[voice];
    if (n_unison > 1)
-      detune += localcopy[id_detune].f * (detune_bias * (float)voice + detune_offset);
+      detune += oscdata->p[5].get_extended(localcopy[id_detune].f) * (detune_bias * (float)voice + detune_offset);
 
    
    float wf = l_shape.v;
@@ -429,6 +429,9 @@ template <bool FM> void SurgeSuperOscillator::convolute(int voice, bool stereo)
       ** over a bunch of tests.
       */
       t = storage->note_to_pitch_inv_ignoring_tuning( detune * storage->note_to_pitch_inv_ignoring_tuning( pitch ) * 16 / 0.9443 + sync );
+
+      // With extended range and low frequencies we can have an implied negative frequency; cut that off by setting a lower bound here.
+      if( t < 0.1 ) t = 0.0;
    }
    else
        t = storage->note_to_pitch_inv_tuningctr(detune + sync);
diff --git a/src/common/dsp/WavetableOscillator.cpp b/src/common/dsp/WavetableOscillator.cpp
index f1eeeb2f7..50143e11f 100644
--- a/src/common/dsp/WavetableOscillator.cpp
+++ b/src/common/dsp/WavetableOscillator.cpp
@@ -148,7 +148,7 @@ void WavetableOscillator::convolute(int voice, bool FM, bool stereo)
 
    double detune = drift * driftlfo[voice];
    if (n_unison > 1)
-      detune += localcopy[id_detune].f * (detune_bias * float(voice) + detune_offset);
+      detune += oscdata->p[5].get_extended(localcopy[id_detune].f) * (detune_bias * float(voice) + detune_offset);
 
    // int ipos = (large+oscstate[voice])>>16;
    const float p24 = (1 << 24);
@@ -232,6 +232,7 @@ void WavetableOscillator::convolute(int voice, bool FM, bool stereo)
    {
       // See the comment in SurgeSuperOscillator.cpp at the absolute treatment
       tempt = storage->note_to_pitch_inv_ignoring_tuning( detune * storage->note_to_pitch_inv_ignoring_tuning( pitch_t ) * 16 / 0.9443 );
+      if( tempt < 0.1 ) tempt = 0.1;
    }
    else
       tempt = storage->note_to_pitch_inv_tuningctr(detune);
diff --git a/src/common/dsp/WindowOscillator.cpp b/src/common/dsp/WindowOscillator.cpp
index da511e49d..c1db71b54 100644
--- a/src/common/dsp/WindowOscillator.cpp
+++ b/src/common/dsp/WindowOscillator.cpp
@@ -246,11 +246,12 @@ void WindowOscillator::process_block(float pitch, float drift, bool stereo, bool
    if( oscdata->p[5].absolute )
    {
       // See comment in SurgeSuperOscillator
-      Detune = localcopy[oscdata->p[5].param_id_in_scene].f * storage->note_to_pitch_inv_ignoring_tuning( std::min( 148.f, pitch ) ) * 16 / 0.9443;
+      Detune = oscdata->p[5].get_extended(localcopy[oscdata->p[5].param_id_in_scene].f)
+         * storage->note_to_pitch_inv_ignoring_tuning( std::min( 148.f, pitch ) ) * 16 / 0.9443;
    }
    else
    {
-      Detune = localcopy[oscdata->p[5].param_id_in_scene].f;
+      Detune = oscdata->p[5].get_extended(localcopy[oscdata->p[5].param_id_in_scene].f);
    }
    for (int l = 0; l < ActiveSubOscs; l++)
    {
diff --git a/src/headless/UnitTestsDSP.cpp b/src/headless/UnitTestsDSP.cpp
index a4a27eb58..7e01df831 100644
--- a/src/headless/UnitTestsDSP.cpp
+++ b/src/headless/UnitTestsDSP.cpp
@@ -77,6 +77,13 @@ TEST_CASE( "Unison Absolute and Relative", "[osc]" )
                             REQUIRE( f72_avg / f60_avg == Approx( 2 ).margin( 0.01 ) );
                             REQUIRE( f72_0 / f60_0 == Approx( 2 ).margin( 0.01 ) );
                             REQUIRE( f72_1 / f60_1 == Approx( 2 ).margin( 0.01 ) );
+
+                            // test extended mode
+                            surge->storage.getPatch().scene[0].osc[0].p[5].extend_range = true;
+                            auto f60_0e = frequencyForNote( surge, 60, 5, 0 );
+                            auto f60_1e = frequencyForNote( surge, 60, 5, 1 );
+                            REQUIRE( f60_0e / f60_avg == Approx( pow( f60_0 / f60_avg, 12.f ) ).margin( 0.05 ) );
+                            REQUIRE( f60_1e / f60_avg == Approx( pow( f60_1 / f60_avg, 12.f ) ).margin( 0.05 ) );
                          };
 
    auto assertAbsolute = [surge](const char* pn, bool print = false) {
@@ -251,7 +258,7 @@ TEST_CASE( "Unison at Sample Rates", "[osc]" )
          
          assertRelative(surge, "test-data/patches/SH-Uni2-Relative.fxp");
          assertAbsolute(surge, "test-data/patches/SH-Uni2-Absolute.fxp");
-         randomAbsolute(surge, "test-data/patches/SH-Uni2-Absolute.fxp");
+         // randomAbsolute(surge, "test-data/patches/SH-Uni2-Absolute.fxp");
       }
    }
 }
